/* EDT (fr) 2007
*/

#ifdef WINDOWS
#include <io.h>     /* for access() */
#else
#include <unistd.h> /* for access() */
#endif

#include "edt.h"

#define IDENTLINE  "EDT 0.5  cg/fr 1988-2007"

#define BETWEEN(min,x,max)  ((x) < (min) ? (min) : ( (x) > (max) ? (max) : (x) ))


static int w;
int h;

char headattr, tailattr, attrcache;
char chbycurs;
int xmax, ymax;

extern char *fmac;

extern char *rmac, *rmace;
static char ymac[ MACSIZE ] = { 0 };
static char zmac[ MACSIZE ] = { 0 };
int cmac;
static char *amac;

char agcom;

static char idline[]= IDENTLINE;

static char tl[]=
"<space> <curs> Again Buffer Copy Delete eXchange Find -find Get Insert Jump Macro Put Quit Replace Set Y Z & @  <F1>=Help";

static char tlro[]=
"<curs> Again Find Jump Put Quit @";

char *topline;
static char *tle;

static char *lb0;
char *lb;
char *le;
unsigned bufsize;

extern char cpb[], *cpbe;
extern char *al, *als, *alp;
extern int alshifted, glc, rgc;

extern int cursx, cursy;
static int comcnt;
int cnt;
int asking;
int lstcom, precom;
extern int tabs, ctrl;
extern nodraw;
extern char *fsl,*nsl;

extern char fstr[];
static char indfname[FILENAMELEN]= "";
static FILE *lastf;

char ininame[ FILENAMELEN ]= "";
int changed= 0;

int indent;
extern char delbuf;

char readonly;



static void clean( void )
{
   visual( fsl, 3 );
   topstr( 0 );
   message("");
   pralnum();
}


static void nextop( void )
{
char * topend;

   topline += xmax;
   while( *topline != ' ' && *topline != '\0' )
      topline--;
   if( topline >= tle )
      topline = tl;
   else if( *topline == '\0' )
      *topline = ' ';
   topend = topline + xmax;
   if( topend < tle )
   {
      while( *topend != ' ' )
         topend--;
      *(topend) = '\0';
   }
}


static int repl( char c, char *s, char r )
{
   if( strchr( s, c ) )
      return r;
   else
      return c;
}


static void topmenu( void )
{
register char c;

  cmac= 0;
  amac= 0;
   agcom= 0;
   c = readonly ? ' ': 'i';
   goto begin;

   for(;;){
    if( cmac>0 && fmac==0 ){ cmac--; fmac= amac; }
    c= getach();
    if( readonly )
       c = repl( c, "bcdghimrsxyzBCDGHIMRSXYZ&-<?\026\b\031", 033);
    if( c=='?' ){
       asking=1;
       message( "--> ?" );
       rstc();
       continue;
    }
    if( isdigit( c ) ){
      if( (comcnt= comcnt*10 + c - '0') <0 ) comcnt= 0x7fff;
      message( "--> %1d", comcnt );
      rstc();
      continue;
    }
    if( (cnt= comcnt)==0 ) cnt=1;
    else{
       clrmsg();
       rstc();
    }
begin:
    comcnt= 0;
    switch( c ){
      case 033: topstr( topline );
                break;
      case SPECIAL:
                if( cursmenu( c ) )
                {
                  if( !chbycurs )   stype( "\07" );
                } if( !chbycurs ) break;
      case 'V' & 077:
      case 'i':
      case 'I': insmenu( 1 ); break;
      case 'x':
      case 'X': insmenu( 0 ); break;
      case ' ': nextop();
                topstr( topline );
                break;
      case '@': clean(); break;
      case 'q':
      case 'Q': if( !readonly )
                   if( (c=qumenu()) != 0 ) goto begin;
                return;
      case '&': if( !ansyn( "Update & Exit ? ", "" ) ) break;
                wrfile( ininame ); if(changed) break; else return;
      case 's':
      case 'S': setmenu(); break;
      case 'j':
      case 'J': vl( cnt-pralnum(), 0); break;
      case 'd':
      case 'D': delmenu(); break;
      case 'f':
      case 'F': findmenu( cnt ); agcom=c; break;
      case '-': mfindmenu( cnt ); agcom=c; break;
      case 'a':
      case 'A': again( agcom, cnt ); break;
      case 'r':
      case 'R': repmenu( cnt, asking ); agcom = asking ? 'R' : 'r'; break;
      case 'c':
      case 'C': for(; cnt>0; cnt--) copymen(); pralnum(); break;
      case 'b':
      case 'B': bufmen(); break;
      case 'g':
      case 'G': getmen(); break;
      case 'p':
      case 'P': putmen(); break;
      case 'y':
      case 'Y': if( *ymac && !rmac && !fmac ){ cmac= cnt; amac= ymac; }
               break;
      case 'z':
      case 'Z': if( *zmac && !rmac && !fmac ){ cmac= cnt; amac= zmac; }
               break;
      case 'm':
      case 'M': if( rmac ){
                  *--rmac= 0; rmac=0;
                  message( "finished macro recording" );
               }else{
                  message( "record macro Y or Z ? " );
                  do{
                     c= getach() & 0x5f;
                  }while( c!='Y' && c!='Z' && !isesc(c) );
                  if( isesc(c) ) break;
                  message( "'M' : finish macro recording" );
                  if( c== 'Y' ) rmac= ymac;
                  else rmac= zmac;
                  rmace= rmac+ MACSIZE-2;
               }
               break;
      case '\r':glc=0; drawal(); vl( 0,cnt ); lstcom=0; break;

      case 'h':
      case 'H': help(); break;

      default:  if( cursmenu( c ) ) stype( "\07" );
    }
    rstc();
    asking= 0;
  }
}


void help()
{
int not;

   not = 1;

   if( access("edt.hlp",0) == 0 )
   {
      not = system("edt edt.hlp r");
   }

   if( not )
      message("--> help not available");
   else
      clean();
}


void initialize( char * fn )
{
int r;
int normal, reverse;

   normal  = CO_NORMAL;      /* color only */
   reverse = CO_REVERSE;

   xmax = w;
   ymax = h;

   le= als= alp= al= fsl= nsl= lb;
   cpb[0]=0;
   cpbe= cpb;
   asking= comcnt= 0;
   indent= 1;
   nodraw= 0;
   delbuf=1;

   headattr = reverse;
   tailattr = normal;
   attrcache= 0;
   topstr( idline );
   stc(1,2);
   stype( "--" );
   strncpy( ininame, fn, sizeof ininame - 1 );
   if( (r = rdfile( fn, lb ) ) > 0 )
      type( " /new ! %u free", bufsize );
   else if( r == 0 )
      type( " %u/%u chars", le-lb, bufsize );
   if( le== lb ){ *le++=0; *le++=0; }
   tabs= 8;
   ctrl= 0;
   glc= 0;
   visual( lb, 3 );
   changed= 0;
   setc( 1, 3 );
   if( readonly )
      strcpy( tl, tlro );
   tle = tl + strlen(tl);
   topline = tle;
   nextop();
}


static void doit( char * fn, int lin, int col )
{
   for( bufsize = BUFSIZE; bufsize >= MINBUFSIZE; bufsize /= 2 )
   {
      lb0 = malloc( bufsize+2 );
      if( lb0 )
         break;
   }
   if( !lb0 )
   {
      stype("EDT: not enough memory\n");
      exit( 2 );
   }

   lb = le = lb0 + 2;
   *(long *)lb0 = 0L;

   fmac = 0;
   kbraw();
   initialize( fn );
   vl( lin-1, 0 );
   shcurs( col-1 );
   topmenu();
   lastf = fopen( LASTFILE, "wb" );
   if( lastf )                         /* update the  last-file     */
   {
      fprintf( lastf, "%s %u %u\n", fn, pralnum(), alp-al+1 );
      fclose( lastf );
   }
   kbcooked();
}


static void usage( void )
{
  stype( "USAGE: edt [ file | + ]\r\n" );
  exit( 1 );
}


int main( int c, char *v[] )
{
char *fn;
extern char *nxtline();
int lin, col;
long l;
char * lastp, * p;

   if( c>3 )
      usage();

   w = 80;
   h = 25;
   getscrsize( &w, &h );

   readonly = c == 3;
   fn = "noname";
   lin = 1;
   col = 1;
   lastf = 0;
   if( c >= 2 )
   {
      if( *v[1] == '+' )
      {
         lastf=fopen(LASTFILE,"r+b");
         if( lastf )
         {
            fseek( lastf, 0L, SEEK_END );
            l = ftell( lastf );        /* file length               */
            fseek( lastf, 0L, SEEK_SET );
            if( (l > 0) && ((lastp=malloc((int)(l+1))) != NULL) )
            {
               *lastp = 0;             /* read the  last-file:      */
               fread( lastp, 1, (unsigned)l, lastf );
               *(lastp + (unsigned)l ) = 0;
               p = lastp;
               while( *p )
               {
                  if( *p == ' ' )
                     break;
                  p++;
               }
               *p = 0;
               fn = lastp;
               p++;
               lin = atoi(p);
               while( *p )
               {
                  if( *p < '0' )
                     break;
                  p++;
               }
               col = atoi(p);
            }
         }
      }
      else
         fn = v[1];
   }

   doit( fn, lin, col );

   stc( 1, h );
   ceol();
//   stc( 1, h-1 );
   exit( 0 );
   return 0;
}


