/* EDT (fr) 2007
   OS/2 : open watcom 1.6
*/

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#define FILENAMELEN 300
#define BUFSIZE  (1024*1024)  /* 1M text buffer      */
#define MINBUFSIZE (32*1024)  /* min 32k text buffer */
#define CPSIZE (32*1024)      /* copy buffer size    */
#define MACSIZE 200           /* max macro size      */

#define LASTFILE "edt.l"

/* color attributes  */
#define CO_NORMAL  0x1F       /* white on blue  */
#define CO_REVERSE 0x71       /* blue on white  */


#define isesc(c)   ( (c) == 033 )
#define SPECIAL    0x10

/* special char codes (2nd byte) : */
#if defined(OS2) || defined(WINDOWS)
#define K2LEFT  'K'
#define K2RIGHT 'M'
#define K2UP    'H'
#define K2DN    'P'
#define K2PGUP  'I'
#define K2PGDN  'Q'
#define K2HOME  'G'
#define K2END   'O'
#define K2DEL   'S'
#define K2INS   'R'
#define K2F1    ';'
#endif
#ifdef LINUX
#define LINEOVERFLOW '~'
#define K2LEFT  'D'
#define K2RIGHT 'C'
#define K2UP    'A'
#define K2DN    'B'
#define K2PGUP  '5'
#define K2PGDN  '6'
#define K2HOME  'H'
#define K2END   'F'
#define K2DEL   '3'
#define K2INS   '2'
#define K2F1    'P'
#else
#define LINEOVERFLOW '\257'
#endif
#ifdef CUBE
#define K2LEFT  (KEY_CURSLEFT  & 255)
#define K2RIGHT (KEY_CURSRIGHT & 255)
#define K2UP    (KEY_CURSUP    & 255)
#define K2DN    (KEY_CURSDOWN  & 255)
#define K2PGUP  (KEY_PGUP      & 255)
#define K2PGDN  (KEY_PGDN      & 255)
#define K2HOME  (KEY_HOME      & 255)
#define K2END   (KEY_END       & 255)
#define K2DEL   (KEY_DEL       & 255)
#define K2INS   (KEY_INS       & 255)
#define K2F1    (KEY_F1        & 255)
#endif


void   initialize( char * fn );
void   help(void);
int    cmpal(int  g);
void   leaveal(void);
void   drawal(void);
void   retypeal(void);
void   copymen(void);
void   getmen(void);
void   putmen(void);
void   bufmen(void);
void   delmenu(void);
int    rdfile(char * fn,char * pos);
void   wrfile(char * fn);
int    ptfile(char * fn,char * s,char * e);
int    cursmenu(char  c);
int    getach(void);
void   insmenu(int  i);
int    qumenu(void);
void   setmenu(void);
void   shcurs(int  c);
void   delch(int  c);
void   bdel(char * f,char * t);
char * findmenu(int  c);
char * mfindmenu(int  c);
char * mfind( char * f );
void   again(char  c,int  a);
void   repmenu(int  c,int  ask);
void   setc(int  x,int  y);
void   stc(int  x,int  y);
void   rstc(void);
void   ceol(void);
void   clrl(int  y);
void   scrup(int  a,int  b);
void   scrdn(int  a,int  b);
int    tstr(char * s,int  x);
int    cntch(char * s,char * e);
char * posinline(char * s,int  g);
int    getdefstr(char * t,char * s);
void   topstr(char * s);
void   clrmsg(void);
void   copy(char * t,char * f,unsigned n);
char * thline(char * l);
char * nxtline(char * p);
char * lstline(char * p);
int    pralnum(void);
char * mkroom(char * loc,int  anz);
void   delblk(char * f,char * t);
char * pfind(char * f);
void   visual(char * l,int  my);
void   vl(int  cr,int  wr);
int    wscdn(int  y,char * l);
void   wscup(int  y,char * l);
int    cnsl(void);
void   stype( char * );
void   type( char * format, ... );
void   message( char * format, ... );
void   getscrsize( int * w, int * h );
int    getchw( void );
int    ansyn( char * s, char * t );
char * anss( char * s );
void   kbraw( void );
void   kbcooked( void );

