#include <stdarg.h>

#include "edt.h"

extern int xmax;

#define DEL   (0177)
#define RET   ('\r')
#define MAXSTR 64
#define LINLEN 1010

static char ansstr[ MAXSTR ];

int ctrl= 1;
int tabs= 3;

int cursx= 1;
int cursy= 3;

int nodraw= 0;

static char dlcstr[]= "\b \b";


/* generic SCREEN PRIMITIVES */
void setc( int x, int y )
{
   stc( (cursx=x), (cursy=y));
}


void rstc()
{
   stc(cursx, cursy);
}


void clrl( int y )
{
   stc( 1, y);
   ceol();
}


static char * chtos( char * s, unsigned char c, int * x )
{
  if( c=='\t' ){
    do{ *s++ = ' ' ; }while( ++*x % tabs );
  }else{
    ++*x;
    if( c>= ' ') *s++ = c;
    else if( ctrl ){
      ++*x;
      *s++ = '^';
      *s++ = (c&037)|0100;
    }else *s++ = (c>=7 && c<=13) || (c==0) ? '\260' : c;
  }
  *s = 0;
  return( s );
}


void type( char * format, ... )
{
static char buf[200];
va_list ap;

   va_start( ap, format );
   vsprintf( buf, format, ap );
   va_end( ap );
   stype( buf );
}


void clrmsg()
{
  stc(1,2);
  stype( "--" );
  ceol();
}


void message( char * format, ... )
{
static char buf[200];
va_list ap;

   clrmsg();
   va_start( ap, format );
   vsprintf( buf, format, ap );
   va_end( ap );
   stype( buf );
}


int tstr( s,x )
register char *s;
int x;
{
 char buf[LINLEN];
 char *b;
 int xmaxx;

   xmaxx = xmax - x - 2;
   b = buf;
   *b = 0;
   while( *s && x< (xmax-2) ){
     b= chtos( b, *s++, &x );
   }
   buf[xmaxx] = LINEOVERFLOW;
   buf[xmaxx+1] = 0;
   stype(buf);
   ceol();

   return( x );
}


int cntch( s,e )
register char *s, *e;
{
register int c;
  c=0;
  while( s<e ){
    if( *s== '\t' ) while( ++c%tabs );
    else{
      ++c;
      if( ctrl && (*s<' ' || *s>=DEL)) ++c;
    }
    ++s;
  }
  return( c );
}


char * posinline( s,g )
register char *s;
register int g;
{
register int c;
  c= 0;
  while( *s && c++< g ){
    if( *s== '\t' ){ if(c%tabs==0)++s; }
    else{
      if( ctrl && (*s<' '||*s>=DEL)) ++c;
      ++s;
    }
  }
  return( s );
}


static char * getstr( register char * s, int max )
{
char *ss;
int x,xl;
char b[10];

  x=0; --max; ss=s;
  while( (*s=getach())!=RET && (s-ss)<max ){
    if( s== ss ) ceol();
    if( *s==DEL || *s=='\b' ){
      if( s>ss ){
        xl= cntch( ss, --s );
        while( x > xl ){ --x;  stype( dlcstr ); }
      }
    }else if( (unsigned char)*s>= ' ' || *s=='\t' ){
      chtos( b, *s++, &x );
      stype( b );
    }
    else if( *s==('Q'&077) ) { chtos( b, (*s++=getach()&077), &x ); stype( b ); }
    else if( isesc(*s) ) return( 0 );
    fflush( stdout );
  }
  *s= 0;
  return( s );
}


getdefstr( t,s )
char *t, *s;
{
char *a;
int c;
   clrmsg();
   c=3;
   nodraw=0;
   c+= tstr( t, 0 );
   stype( "\"" );
   c++;
   tstr( s, 0 );
   stype( "\"" );
   stc( c, 2 );
   a= getstr( ansstr, MAXSTR );
   if( a== 0 ) return( 0 );
   if( ansstr != a ){
      strcpy( s, ansstr );
      stype( "\"" );
   }else{
      type( "%s\"", s );
   }
   return( 1 );
}


void topstr ( s )
char * s;
{
static char old[80];

   if( s )
      strcpy( old, s );
   clrl(1);
   stype( old );
}


int ansyn( char * s, char * t )
{
char c;

   message( s,t );
   if( xmax >= 36 )
      stype( "(y/n) " );
   do
   {
      c = getach();
      c = toupper( c );
   } while( (c!='Y')&&(c!='N') );
   type( "%c", c );
   return( c=='Y' );
}


char * anss( char * s )
{
  message( s );
  if( getstr( ansstr, MAXSTR ) == 0 ) *ansstr=0;
  return( ansstr );
}


